#!/usr/bin/env python3

import xml.etree.ElementTree as ET
import rclpy

from elphel_interfaces.srv import StrReqStrRes
import ros2_config

import sys
import html

# etree
#a = '<document><cmd>&</cmd></document>'

#xml = ET.Element("document")
#ET.SubElement(xml, "cmd").text = "begin & end"

#a = ET.tostring(xml)
#print(a)

#e = ET.fromstring(a)
#print(e)

#print(html.escape(e.find("cmd").text))

#sys.exit()

rclpy.init()
node = rclpy.create_node('some_client_node')

cli = node.create_client(StrReqStrRes, 'master_1467cd/cmd')

wcnt = 0
while not cli.wait_for_service(timeout_sec=1.0):
  print('Service is not available, waiting '+str(wcnt)+'...')
  wcnt += 1

###############################################################################

print("TEST1")

req = StrReqStrRes.Request()
req.request = '''<document>
  <cmd>state</cmd>
</document>
'''

future = cli.call_async(req)
rclpy.spin_until_future_complete(node, future)
res = future.result().response

node.get_logger().info("cmd response:")
node.get_logger().info("\n"+res)

###############################################################################

print("TEST2")

req = StrReqStrRes.Request()
req.request = '''<document>
  <cmd>wget -qO- -o /dev/null 'http://localhost/parsedit.php?immediate&amp;TRIG'</cmd>
</document>
'''

future = cli.call_async(req)
rclpy.spin_until_future_complete(node, future)
res = future.result().response

node.get_logger().info("cmd response:")
node.get_logger().info("\n"+res)
###############################################################################

node.destroy_node()
rclpy.shutdown()
