#!/usr/bin/env python3

import subprocess
import xml.etree.ElementTree as ET
import html

import rclpy
from elphel_interfaces.srv import StrReqStrRes
import ros2_config

TIMEOUT = 5

def parse_command(string):

  msg = {}

  e = ET.fromstring(string)

  tmp = e.find('cmd');
  if tmp!=None:
    msg['cmd'] = tmp.text
  else:
    msg['cmd'] = 'state'

  return msg


# slave callbacks
def cmd_callback(req,res):

  q = parse_command(req.request)
  print("parsed command by slave:")
  print(q)

  if q['cmd']=='state':
    res.response = '<state>idle</state>'
  else:
    # call to localhost here, get response and send it back
    try:
      output = subprocess.check_output(q['cmd'],shell=True)
    except subprocess.CalledProcessError:
      output = "<error>CalledProcessError</error>".encode()

    res.response = '<state>'+html.escape(output.decode())+'</state>'

  print('Slave sending: '+res.response)

  return res

# global
cfg = ros2_config.get(pre='_slave_')

nodename = cfg['self']

rclpy.init()
node = rclpy.create_node(nodename)

print('\nStarting slave services:')
print('  '+nodename+'/cmd')
s = node.create_service(StrReqStrRes, nodename+'/cmd', cmd_callback)

rclpy.spin(node)

# Destroy the node explicitly
# (optional - Done automatically when node is garbage collected)
node.destroy_node()
rclpy.shutdown()


  #xml = ET.Element("response")

  ##ET.SubElement(doc, "field1", name="blah").text = "some value1"
  ##ET.SubElement(doc, "field2", name="asdfasd").text = "some vlaue2"

  #for k,v in cfg['slaves'].items():
    #xml_node = ET.SubElement(xml, "node")
    #ET.SubElement(xml_node, "name").text = k
    #ET.SubElement(xml_node, "id").text = v

    #if v in nodelist:
      #s = "online"
    #else:
      #s = "offline"

    #ET.SubElement(xml_node, "status").text = s

  #xml_str = ET.tostring(xml).decode()
  #xml_str = minidom.parseString(xml_str).toprettyxml(indent="  ")

  #return xml_str
